<template>
    <div class="investors-filter">
        <base-filter :params="filterParams"
            v-model="filterData"
            :pickerOptions="pickerOptions"
            @apply="initFilter"
            @reset="resetFilter"
        >
            <download-csv-btn slot="btns-after" :filter="filterData" list-type="subscribers"/>
        </base-filter>
    </div>
</template>

<script>
import { subscribersFilterSettings, defaultSubscribersFilter } from '@/constants/ui/filters';
import { mapState } from 'vuex';
import filterMixin from '@/mixins/filterMixin';
import BaseFilter from './baseFilter';
import DownloadCsvBtn from '@/components/DownloadCsvBtn';

export default {
    name: 'subscribersFilter',
    components: {
        BaseFilter,
        DownloadCsvBtn,
    },
    mixins: [filterMixin],
    data() {
        return {
            filterSettings: subscribersFilterSettings,
            filterData: defaultSubscribersFilter,
        };
    },
    computed: {
        ...mapState('subscribers', {
            serverFilter: state => state.filter,
        }),
    },
    methods: {
        /** Apply new subscriber filter params */
        initFilter() {
            this.initLoading(this.$store.dispatch('subscribers/filterList', this.filterData));
        },
        /** Reset current subscriber filter params */
        resetFilter() {
            this.filterData = { ...defaultSubscribersFilter };
            this.$store.commit('subscribers/setFilter', defaultSubscribersFilter);
        },
    },
};
</script>
